#include "chil_global.h"

int
CHILOpen(char * filename, ChilboltonFile * chilfile)
{
  char *dot;
  char tmp[255];
  FILE *sumfile;

  if ((chilfile->file=fopen(filename,"r")) == NULL) {
    chilfile->position = FILE_CLOSED;
    return FILE_CLOSED;
  }
  chilfile->nrasters=0;
  chilfile->summary_exists=0;
  chilfile->bytes_read=0;
  chilfile->is_raw=0;
  chilfile->iraster=0;
  chilfile->iscan=0;
  chilfile->cals_constant = 0;
  strncpy(chilfile->name,filename,MAX_FILENAME_LENGTH);
  chilfile->name[MAX_FILENAME_LENGTH-1]='\0';
  if ((dot=strrchr(filename,'.')) != '\0') {
    if (strncmp(dot+1,"raw",3) == 0)
      chilfile->is_raw = 1;
    else {
      if ((sumfile=CHILOpenSummary(filename)) != NULL) {
	int first_raster = 1;
	float old_Zcal = 0, new_Zcal;
	float old_ZDRcal = 0, new_ZDRcal;

	chilfile->summary_exists=1;
	fgets(tmp,255,sumfile); /* skip first line */
	while(fgets(tmp, 255, sumfile) != '\0') {
	  sscanf(tmp, "%5hu %3hu %*8c %2hu/%2hu/%2hu %*10c%5f%3f",
		 (chilfile->block)+(chilfile->nrasters),
		 (chilfile->raster)+(chilfile->nrasters),
		 (chilfile->day)+(chilfile->nrasters),
		 (chilfile->month)+(chilfile->nrasters),
		 (chilfile->year)+(chilfile->nrasters),
		 &new_Zcal, &new_ZDRcal);
	  if (first_raster) {
	    chilfile->cals_constant = 1;
	    first_raster = 0;
	  }
	  else if (new_Zcal != old_Zcal || new_ZDRcal != old_ZDRcal) {
	    chilfile->cals_constant = 0;
	  }
	  old_Zcal = new_Zcal;
	  old_ZDRcal = new_ZDRcal;

	  (chilfile->nrasters)++;
	}

	chilfile->Zcal = new_Zcal;
	chilfile->ZDRcal = new_ZDRcal/8;

	fclose(sumfile);
      }
    }
  }
  chilfile->position = START_OF_FILE;
  return START_OF_FILE;
}

int
CHILClose(ChilboltonFile * chilfile)
{
  int status = 0;
  chilfile->position = FILE_CLOSED;
  status = fclose(chilfile->file);
  chilfile->file = NULL;
  return status;
}

